/* @(#)module_indexer.pl	1.9 29 Sep 1993

Since this file is only used by term_expansion/2, it should be loaded with

:- load_files(indexer(module_indexer), when(compile_time),if(changed)]).

See the README in this directory.

This software is free: please copy it and/or modify it. Do with it what
you like.  It is a gift from KnowledgeWare Inc, and was written by Tom
Howland.

*/

:- module(module_indexer, []).

:- use_module(low).
:- use_module(library(addportray)).

% user:t(X) :- expand_module_index_directive((:-module_index(foo(+))), X).

/* I know it is discusting to use univ (=..). Please don't tell me. */

expand_module_index_directive((:-module_index(Specs)), Clauses) :-
    index_clauses(Specs, Clauses1, ModInit, Head, _, Mod, _, _,
		  ClauseNumber, Body, Hash, TrueHash),
    Clauses = [:-(discontiguous('** indexed assert **'/1)),
	       :-(discontiguous('** indexed retract **'/1)),
	       :-(discontiguous('** indexed **'/1)),
	       '** indexed **'(TrueHead),
	       (TrueHead:-TrueHash, Call),
	       HashAssert, HashRetract | Clauses1],
    Call = M:TrueNewHead,
    Head =.. [N|X], TrueHead =.. [N,M|X],
    Hash =.. [HN|Hx], TrueHash =.. [HN,M|Hx],
    parse_index_specs(Specs, Head, Mod, M, ClauseNumber, Body, HAB1, HRB,
		      Refs, _, _, _, ModInit, NewTrueName, NewTrueArity),
    tidy(HAB1,HAB),

    functor(Head, Name, Arity),
    concat_atom(['** ',Name,'/',Arity,' **'], NewTrueName),
    append([NewTrueName, ClauseNumber], X, X1),
    append(X1, Refs, TrueNewHeadList),
    TrueNewHead =.. TrueNewHeadList,
    functor(TrueNewHead, _, NewTrueArity),

    concat_atom(['clause count ', Name, '/', Arity], ClauseCount),
    functor(CCi,ClauseCount,1),
    arg(1, CCi, ClauseNumber),
    functor(CCf,ClauseCount,1),
    arg(1, CCf, CC),
    HashAssert=('** indexed assert **'(TrueHead):-
	       (   retract(M:CCi)
	       ->  true
	       ;   ClauseNumber is 0
	       ),
	       CC is ClauseNumber+1,
	       assert(M:CCf),
	       HAB,
	       assert(M:TrueNewHead)),
    HashRetract=('** indexed retract **'(TrueHead):-TrueHash,
		retract(M:TrueNewHead),HRB).

:- initialization
    add_linking_clause(expand_module_index_directive, term_expansion, 2),
    op(1150, fx, module_index).
